# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DebPackageResponse(BaseModel):
    """
    A Serializer for Package.
    """ # noqa: E501
    pulp_href: Optional[StrictStr] = None
    prn: Optional[StrictStr] = Field(default=None, description="The Pulp Resource Name (PRN).")
    pulp_created: Optional[datetime] = Field(default=None, description="Timestamp of creation.")
    pulp_last_updated: Optional[datetime] = Field(default=None, description="Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.")
    pulp_labels: Optional[Dict[str, Optional[StrictStr]]] = Field(default=None, description="A dictionary of arbitrary key/value pairs used to describe a specific Content instance.")
    artifact: Optional[StrictStr] = Field(default=None, description="Artifact file representing the physical content")
    relative_path: Optional[StrictStr] = Field(default=None, description="Path where the artifact is located relative to distributions base_path")
    distribution: Optional[StrictStr] = Field(default=None, description="Name of the distribution.")
    component: Optional[StrictStr] = Field(default=None, description="Name of the component.")
    md5: Optional[StrictStr] = Field(default=None, description="The MD5 checksum if available.")
    sha1: Optional[StrictStr] = Field(default=None, description="The SHA-1 checksum if available.")
    sha224: Optional[StrictStr] = Field(default=None, description="The SHA-224 checksum if available.")
    sha256: Optional[StrictStr] = Field(default=None, description="The SHA-256 checksum if available.")
    sha384: Optional[StrictStr] = Field(default=None, description="The SHA-384 checksum if available.")
    sha512: Optional[StrictStr] = Field(default=None, description="The SHA-512 checksum if available.")
    package: Optional[StrictStr] = None
    source: Optional[StrictStr] = None
    version: Optional[StrictStr] = None
    architecture: Optional[StrictStr] = None
    section: Optional[StrictStr] = None
    priority: Optional[StrictStr] = None
    origin: Optional[StrictStr] = None
    tag: Optional[StrictStr] = None
    bugs: Optional[StrictStr] = None
    essential: Optional[StrictStr] = None
    build_essential: Optional[StrictStr] = None
    installed_size: Optional[StrictStr] = None
    maintainer: Optional[StrictStr] = None
    original_maintainer: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    description_md5: Optional[StrictStr] = None
    homepage: Optional[StrictStr] = None
    built_using: Optional[StrictStr] = None
    auto_built_package: Optional[StrictStr] = None
    multi_arch: Optional[StrictStr] = None
    breaks: Optional[StrictStr] = None
    conflicts: Optional[StrictStr] = None
    depends: Optional[StrictStr] = None
    recommends: Optional[StrictStr] = None
    suggests: Optional[StrictStr] = None
    enhances: Optional[StrictStr] = None
    pre_depends: Optional[StrictStr] = None
    provides: Optional[StrictStr] = None
    replaces: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["pulp_href", "prn", "pulp_created", "pulp_last_updated", "pulp_labels", "artifact", "relative_path", "distribution", "component", "md5", "sha1", "sha224", "sha256", "sha384", "sha512", "package", "source", "version", "architecture", "section", "priority", "origin", "tag", "bugs", "essential", "build_essential", "installed_size", "maintainer", "original_maintainer", "description", "description_md5", "homepage", "built_using", "auto_built_package", "multi_arch", "breaks", "conflicts", "depends", "recommends", "suggests", "enhances", "pre_depends", "provides", "replaces"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DebPackageResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "pulp_href",
            "prn",
            "pulp_created",
            "pulp_last_updated",
            "md5",
            "sha1",
            "sha224",
            "sha256",
            "sha384",
            "sha512",
            "package",
            "source",
            "version",
            "architecture",
            "section",
            "priority",
            "origin",
            "tag",
            "bugs",
            "essential",
            "build_essential",
            "installed_size",
            "maintainer",
            "original_maintainer",
            "description",
            "description_md5",
            "homepage",
            "built_using",
            "auto_built_package",
            "multi_arch",
            "breaks",
            "conflicts",
            "depends",
            "recommends",
            "suggests",
            "enhances",
            "pre_depends",
            "provides",
            "replaces",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DebPackageResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pulp_href": obj.get("pulp_href"),
            "prn": obj.get("prn"),
            "pulp_created": obj.get("pulp_created"),
            "pulp_last_updated": obj.get("pulp_last_updated"),
            "pulp_labels": obj.get("pulp_labels"),
            "artifact": obj.get("artifact"),
            "relative_path": obj.get("relative_path"),
            "distribution": obj.get("distribution"),
            "component": obj.get("component"),
            "md5": obj.get("md5"),
            "sha1": obj.get("sha1"),
            "sha224": obj.get("sha224"),
            "sha256": obj.get("sha256"),
            "sha384": obj.get("sha384"),
            "sha512": obj.get("sha512"),
            "package": obj.get("package"),
            "source": obj.get("source"),
            "version": obj.get("version"),
            "architecture": obj.get("architecture"),
            "section": obj.get("section"),
            "priority": obj.get("priority"),
            "origin": obj.get("origin"),
            "tag": obj.get("tag"),
            "bugs": obj.get("bugs"),
            "essential": obj.get("essential"),
            "build_essential": obj.get("build_essential"),
            "installed_size": obj.get("installed_size"),
            "maintainer": obj.get("maintainer"),
            "original_maintainer": obj.get("original_maintainer"),
            "description": obj.get("description"),
            "description_md5": obj.get("description_md5"),
            "homepage": obj.get("homepage"),
            "built_using": obj.get("built_using"),
            "auto_built_package": obj.get("auto_built_package"),
            "multi_arch": obj.get("multi_arch"),
            "breaks": obj.get("breaks"),
            "conflicts": obj.get("conflicts"),
            "depends": obj.get("depends"),
            "recommends": obj.get("recommends"),
            "suggests": obj.get("suggests"),
            "enhances": obj.get("enhances"),
            "pre_depends": obj.get("pre_depends"),
            "provides": obj.get("provides"),
            "replaces": obj.get("replaces")
        })
        return _obj


